import React from 'react';
import ReactTooltip from 'react-tooltip';

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;

  _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

var Copi = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(Copi, _React$Component);

  function Copi(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    _this.refs = props.ref ? props.ref : React.createRef();
    _this.image = props.image;
    _this.style = props.style;
    _this.width = props.imageWidth;
    _this.height = props.imageHeight;
    _this.copyCoordinates = props.copyCoordinates === true ? true : false;
    _this.hoverCallback = props.hoverCallback ? props.hoverCallback : function (x, y, color) {};
    _this.theme = ["dark", "light"].indexOf(props.theme) ? props.theme : "dark";
    _this.state = {
      x: 0,
      y: 0,
      color: null,
      copied: false
    };
    return _this;
  }

  var _proto = Copi.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var self = this;
    var imgObj = new Image(this.width, this.height);
    imgObj.src = this.image;

    imgObj.onload = function () {
      self.refs.canvas.getContext('2d').drawImage(imgObj, 0, 0, this.width, this.height);
    };
  };

  _proto._colorPicker = function _colorPicker(e, copied) {
    function rgbToHex(r, g, b) {
      if (r > 255 || g > 255 || b > 255) throw "Invalid color component";
      return (r << 16 | g << 8 | b).toString(16);
    }

    var x = e.nativeEvent.offsetX;
    var y = e.nativeEvent.offsetY;
    var imageData = this.refs.canvas.getContext("2d").getImageData(x, y, 1, 1).data;
    var hex = "#" + ("000000" + rgbToHex(imageData[0], imageData[1], imageData[2])).slice(-6);

    if (copied) {
      var copyContent = this.copyCoordinates ? '{"x": ' + x + ', "y": ' + y + ', "color": "' + hex + '"}' : hex;
      navigator.clipboard.writeText(copyContent);
      copied = true;
    } else {
      copied = false;
    }

    this._setState(x, y, hex, copied);
  };

  _proto._setState = function _setState(x, y, color, copied) {
    this.setState({
      x: x,
      y: y,
      color: color,
      copied: copied
    });
    this.hoverCallback(x, y, color, copied);
  };

  _proto._initState = function _initState() {
    this._setState(0, 0, null, false);
  };

  _proto._onMouseMove = function _onMouseMove(e) {
    this._colorPicker(e, false);
  };

  _proto._onMouseDown = function _onMouseDown(e) {
    this._colorPicker(e, true);
  };

  _proto.render = function render() {
    var _this2 = this;

    return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("canvas", {
      "data-for": "getDetails",
      style: this.style,
      width: this.width,
      height: this.height,
      onMouseDown: this._onMouseDown.bind(this),
      onMouseMove: this._onMouseMove.bind(this),
      onMouseOut: this._initState.bind(this),
      ref: "canvas",
      "data-tip": true
    }), /*#__PURE__*/React.createElement(ReactTooltip, {
      type: this.theme,
      id: "getDetails",
      getContent: function getContent() {
        return 'x: ' + _this2.state.x + ", y: " + _this2.state.y + ", " + _this2.state.color + (_this2.state.copied ? " - COPIED!" : " - Click to copy");
      }
    }));
  };

  return Copi;
}(React.Component);

export default Copi;
//# sourceMappingURL=index.modern.js.map
